%define confdir %{_sysconfdir}/%{name}

Name:       transifex
Version:    0.5.2
Release:    1%{?dist}
Summary:    A system for distributed translation submissions

Group:      Applications/Internet
License:    GPLv2
URL:        http://transifex.org/
Source0:    http://transifex.org/files/%{name}-%{version}.tar.gz
Source1:    django-settings.py.in
Patch0:     transifex-0.5-docdb.patch
BuildRoot:  %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildArch:  noarch

BuildRequires:  Django python-sphinx gettext-devel
Requires:   Django django-authopenid django-contact-form
Requires:   django-notification django-pagination django-tagging
Requires:   python-markdown python-pygments
Requires:   mercurial
Requires:   intltool >= 0.37.1

%description
Transifex is a web-system that facilitates the process of submitting
translations in remote and disparate version control systems (VCS).

%package extras
Summary:    Additional support for Transifex
Group:      Applications/Internet
Requires:   transifex = %{version}
Requires:   cvs pysvn bzrtools git

%description extras
This package adds extra options to Transifex.

  * cvs support
  * svn support
  * bzr support
  * git support

%prep
%setup -qcTn %{name}
tar --strip-components 1 -zxf %{SOURCE0}
%patch0 -p 1 -b .docdb
sed -e 's!share/locale!.*/locale!' /usr/lib/rpm/find-lang.sh > my-find-lang.sh

%build
rm -rf .hg* build-tools
rm -r vcs/tests
cd docs
make html
cd ..
python manage.py compilemessages --settings settings

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT%{_datadir}/%{name}
find -mindepth 1 -maxdepth 1 -type d \( \( -name .hg -o \
    -name build-tools -o -name docs \) -prune -o -print \) | \
    xargs cp -a -t $RPM_BUILD_ROOT/%{_datadir}/%{name}
cp -a *.py $RPM_BUILD_ROOT%{_datadir}/%{name}
rm -f $RPM_BUILD_ROOT%{_datadir}/%{name}/locale/*/LC_MESSAGES/django.po

for vcs in cvs svn bzr hg git
do
    mkdir -p $RPM_BUILD_ROOT%{_localstatedir}/lib/%{name}/scratchdir/sources/"$vcs"
done

install -d -m 0755 $RPM_BUILD_ROOT/%{confdir}

sed -n -e 's!^\(PROJECT_PATH = \).*$!\1"%{_datadir}/%{name}"!;
    /ADDITIONAL VCS OPTIONS/q;p' \
    $RPM_BUILD_ROOT%{_datadir}/%{name}/settings.py > \
    $RPM_BUILD_ROOT%{confdir}/00-default.conf

sed -n -e '/EXTRA LOCAL SETTINGS/q;/ADDITIONAL VCS OPTIONS/,$p' \
    $RPM_BUILD_ROOT%{_datadir}/%{name}/settings.py > \
    $RPM_BUILD_ROOT%{confdir}/10-extras.conf

sed -e 's!\[\[confpath\]\]!%{confdir}!' %{SOURCE1} > \
    $RPM_BUILD_ROOT%{_datadir}/%{name}/settings.py

sh my-find-lang.sh $RPM_BUILD_ROOT django transifex.lst

%clean
rm -rf $RPM_BUILD_ROOT

%post
# Check to see if the secret key for Django needs setting, and then set it
if grep -q '\[\[SECRETKEY\]\]' %{confdir}/00-default.conf
then
    key=$(python << EOF
import random
print ''.join(chr(random.randint(35, 126)) for x in xrange(40)).replace('&',
    '\&')
EOF
)
    sed -i -e "s!\[\[SECRETKEY\]\]!$key!" \
        %{confdir}/00-default.conf
fi

%files -f transifex.lst
%defattr(-,root,root,-)
%doc LICENSE README docs/_build/html
%dir %{confdir}
%config(noreplace) %{confdir}/00-default.conf
%dir %{_datadir}/%{name}
%{_datadir}/%{name}/__init__.py
%{_datadir}/%{name}/__init__.py[co]
%{_datadir}/%{name}/manage.py
%exclude %{_datadir}/%{name}/manage.py[co]
%{_datadir}/%{name}/settings.py
%{_datadir}/%{name}/settings.py[co]
%exclude %{_datadir}/%{name}/settings_*.py*
%exclude %{_datadir}/%{name}/sample_settings_*.py*
%{_datadir}/%{name}/urls.py
%{_datadir}/%{name}/urls.py[co]
%{_datadir}/%{name}/actionlog
%{_datadir}/%{name}/languages
%{_datadir}/%{name}/projects
%{_datadir}/%{name}/releases
%{_datadir}/%{name}/repowatch
%{_datadir}/%{name}/simpleauth
%{_datadir}/%{name}/simplelock
%{_datadir}/%{name}/site_media
%{_datadir}/%{name}/templates
%{_datadir}/%{name}/txcommon
%{_datadir}/%{name}/translations
%{_datadir}/%{name}/txcollections
%dir %{_datadir}/%{name}/vcs
%{_datadir}/%{name}/vcs/*.py
%{_datadir}/%{name}/vcs/*.py[co]
%dir %{_datadir}/%{name}/vcs/lib
%{_datadir}/%{name}/vcs/lib/*.py
%{_datadir}/%{name}/vcs/lib/*.py[co]
%dir %{_datadir}/%{name}/vcs/lib/support
%{_datadir}/%{name}/vcs/lib/support/__init__.py
%{_datadir}/%{name}/vcs/lib/support/__init__.py[co]
%{_datadir}/%{name}/vcs/lib/support/commands.py
%{_datadir}/%{name}/vcs/lib/support/commands.py[co]
%dir %{_datadir}/%{name}/vcs/lib/types
%{_datadir}/%{name}/vcs/lib/types/__init__.py
%{_datadir}/%{name}/vcs/lib/types/__init__.py[co]
%{_datadir}/%{name}/vcs/lib/types/dummy.py
%{_datadir}/%{name}/vcs/lib/types/dummy.py[co]
%{_datadir}/%{name}/vcs/lib/types/hg.py
%{_datadir}/%{name}/vcs/lib/types/hg.py[co]
%dir %{_localstatedir}/lib/%{name}
%dir %{_localstatedir}/lib/%{name}/scratchdir
%dir %{_localstatedir}/lib/%{name}/scratchdir/sources
%dir %{_localstatedir}/lib/%{name}/scratchdir/sources/hg

%files extras
%defattr(-,root,root,-)
%doc LICENSE README
%config(noreplace) %{confdir}/10-extras.conf
%{_datadir}/%{name}/vcs/lib/support/cvs.py
%{_datadir}/%{name}/vcs/lib/support/cvs.py[co]
%{_datadir}/%{name}/vcs/lib/types/cvs.py
%{_datadir}/%{name}/vcs/lib/types/cvs.py[co]
%{_datadir}/%{name}/vcs/lib/types/svn.py
%{_datadir}/%{name}/vcs/lib/types/svn.py[co]
%{_datadir}/%{name}/vcs/lib/types/bzr.py
%{_datadir}/%{name}/vcs/lib/types/bzr.py[co]
%{_datadir}/%{name}/vcs/lib/support/git.py
%{_datadir}/%{name}/vcs/lib/support/git.py[co]
%{_datadir}/%{name}/vcs/lib/types/git.py
%{_datadir}/%{name}/vcs/lib/types/git.py[co]
%dir %{_localstatedir}/lib/%{name}/scratchdir/sources/cvs
%dir %{_localstatedir}/lib/%{name}/scratchdir/sources/svn
%dir %{_localstatedir}/lib/%{name}/scratchdir/sources/bzr
%dir %{_localstatedir}/lib/%{name}/scratchdir/sources/git

%changelog
* Wed Apr 01 2009 Ignacio Vazquez-Abrams <ivazqueznet+rpm@gmail.com> 0.5.2-1
- Upstream update
  * Fixed ordering of components untranslated by a Release X Lang
  * Fixed missing parameter for the set_stats_for_lang method call
  * Fixed msgfmt to work large files
- Fixed small bug in %%post
- Fixed PROJECT_PATH in the settings

* Mon Mar 30 2009 Ignacio Vazquez-Abrams <ivazqueznet+rpm@gmail.com> 0.5.1-2
- Build with proper tarball

* Thu Mar 26 2009 Ignacio Vazquez-Abrams <ivazqueznet+rpm@gmail.com> 0.5.1-1
- Upstream update
  * Added list of Components untranslated by Lang x Release
  * Fixed stats for projects with intltool support broken
  * Added mercurial compatibility for 1.2.x version
  * Added list of files to the submit form

* Wed Mar 18 2009 Ignacio Vazquez-Abrams <ivazqueznet+rpm@gmail.com> 0.5-1
- Updated to final release

* Wed Mar 18 2009 Ignacio Vazquez-Abrams <ivazqueznet+rpm@gmail.com> 0.5-0.7.rc1.hge0ede2b7056e
- Updated from hg

* Thu Mar 12 2009 Ignacio Vazquez-Abrams <ivazqueznet+rpm@gmail.com> 0.5-0.6.rc1.hgc3439806202e
- Updated from hg

* Thu Mar 12 2009 Ignacio Vazquez-Abrams <ivazqueznet+rpm@gmail.com> 0.5-0.5.rc1.hg450552bc8262
- Updated from hg
- Fixed path error in %%post

* Tue Mar 10 2009 Ignacio Vazquez-Abrams <ivazqueznet+rpm@gmail.com> 0.5-0.4.rc1.hg969db3557e1f
- Updated from hg

* Tue Mar 10 2009 Ignacio Vazquez-Abrams <ivazqueznet+rpm@gmail.com> 0.5-0.3.rc1.hg8a39f3e6146c
- Update to rc1 and a little further

* Mon Mar 09 2009 Ignacio Vazquez-Abrams <ivazqueznet+rpm@gmail.com> 0.5-0.2.hg9f575f26d1db
- Fix build for EL5

* Mon Mar 09 2009 Ignacio Vazquez-Abrams <ivazqueznet+rpm@gmail.com> 0.5-0.1.hg9f575f26d1db
- Remove vcs app tests
- Add support for simple authentication

* Fri Mar 06 2009 Ignacio Vazquez-Abrams <ivazqueznet+rpm@gmail.com> - 0.5-0.0.hg43f8e9924fa2
- Update to 0.5 beta

* Wed Jan 28 2009 Dimitris Glezos <dimitris@glezos.com> - 0.3.2
- Version 0.3.2

* Sat Aug 01 2008 Dimitris Glezos <dimitris@glezos.com> - 0.3.1
- Version 0.3.1

* Sun Jul 20 2008 Dimitris Glezos <dimitris@glezos.com> - 0.3-0
- Version 0.3

* Sun Feb 10 2008 Dimitris Glezos <dimitris@glezos.com> - 0.2-0
- Overhaul of file uploads, now supporting non-UTF uploads
- Admins are now members of 'l10n-admin' group

* Mon Jan 14 2008 Dimitris Glezos <dimitris@glezos.com> - 0.1.1-0
- Corrected a Unicode issue (non-ascii user names)

* Sat Sep 29 2007 Mike McGrath <mmcgrath@redhat.com> - 0.1-5
- Added logrotate and a few other pieces
- Added transifex user and a few permissions changes

* Thu Sep 27 2007 Mike McGrath <mmcgrath@redhat.com> - 0.1-3
- Added BR TurboGears
- Added transifex to cp -adv
- Added a mkdir

* Sat Jun 23 2007 Dimitris Glezos <dimitris@glezos.com> - 0.1-1
- Initial creation
